Rebol [
	Title: "R2Win-Client"
	Date: 7-Nov-2004
	Version: 0.5.0
	File: %R2Win-Client.r
	Author: "jocko"
	Purpose: "Client du serveur R2Win"
	Comments: {inspir de Client-TCP-IP de Clement (J.F. Theis) (RebToWin)
	S'utilise avec le serveur R2Win . }
	Help: %readme.txt
]
ssh: system/script/header

hist: copy []

serveurs: ["127.0.0.1   localhost" "127.0.0.2   local" "52.20.20.90  monPC"]

items-ch1: ["Bloc-notes" "calculatrice" "sendkeys" "Ouvrir" "message" 
	"close" "lancer" "Jouer un son" "Paintbrush" "Volume" "Presse-papier" 
	"Caract. spciaux"	]

forme-commande: does [
switch/default ch1/text [
      "Bloc-notes" [f1/text: "notepad"]
	  "volume"		  [f1/text: "sndvol32"]
	  "calculatrice"    [f1/text: "calc"]
	  "paintbrush"      [f1/text: "pBrush"]
	  "Presse-papier"   [f1/text: "clipbrd"]
	  "Caract. spciaux" [f1/text: "charmap"]		
      "jouer un son"  [f1/text: Reform ["playsound  " (to-dospath Request-file/title/filter "Slection d'un fichier wav" "OK" "*.wav")]]
	  "lancer" [f1/text: reform ["launch  " (to-dospath request-file/title "Slection d'un fichier" "OK")]]
	  "sendkeys" [f1/text: {sendkeys "Sans titre" "<F5>"}]
	  "message"	[f1/text: {message "Sans titre" "16"}]
	  "close"	[f1/text: {close "Sans titre"}]
        ] 
	  [f1/text: reform ["launch  " (to-dospath request-file/title "Slection d'un fichier" "OK") ]]  ; bloc dfaut
	  show f1
]

;------ convertir en un chemin dos/windows -----
to-dospath: func [pstr][
    if none? pstr [return pstr: copy ""]
    pstr: copy form pstr
    replace/all pstr "/" "\"
    remove pstr
    replace pstr "\" ":\"
    pstr
]

;------- envoyer la commande au serveur -----
send-to-svr: func [msg [string!] /local url-serv][
	dns-sel: first parse r1/text " "
   	url-serv: to-url rejoin ["tcp://" dns-sel ":" f2/text]
  	either not error? try [a-port: open url-serv][
    insert a-port msg
    append f3/text rejoin [copy a-port newline]
    show f3
    close a-port
   ][append f3/text rejoin ["Erreur: connexion au serveur impossible" newline] show f3]
]

aPropos: does [
	aid: layout [
		style txt h3 center 180
		style mvh1 vh1 center 180
		mvh1 rejoin [ssh/title " v" ssh/version]
		txt ssh/purpose
		txt ssh/author
		txt to-string ssh/date
		pad 50x20
		button water 80x24 " ok " [unview aid]] view/new center-face aid]

main: layout [
	across space 2x8
	style mlabel vtext bold 70x24 middle right
	style mbar box 456x3 edge [size: 1x1 color: water effect: 'bevel]
	style btn button water
	backdrop water effect [gradient 0x1 80.108.142 192.192.192] ;water silver
	ttr: vh2 400 center rejoin [ssh/title "   v " ssh/version] [aPropos]
	return
	mbar  return
	mlabel "serveur" r1: rotary 200 water data serveurs 
	mlabel 60x24 "port" f2: field 60 "2000" return
	mlabel "dialogue serveur" 
	f3: area 300x150 
	sl1: slider 20x150 [scroll-para f3 sl1] 
	return
	mlabel "commande" f1: field 300x24 arrow up [f1/text: request-list "historique" hist show f1]return
	mlabel "exemples" ch1: choice 150 data items-ch1 [forme-commande]
	pad 20 btn 150 " envoyer commande" [send-to-svr f1/text insert hist to-string f1/text] return
	mbar return
	pad 68
	btn "lancer serveur" [call "R2Win.exe -c"]
	btn "a propos" [aPropos]
	btn 60 "aide" [browse %readme.txt]
	btn 60 "quitter" [quit]
]
view main
